Package: org.apache.groovy.ginq.provider.collection.runtime

## [Groovy] Class QueryableHelper

- org.apache.groovy.ginq.provider.collection.runtime.QueryableHelper

-     @Internal
      @CompileStatic
      class QueryableHelper
      extends Object

  Helper for Queryable

  Since:
    4.0.0

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `String` | `var`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `<T>` | `static T` | `getVar(String name)`
    `` | `static boolean` | `isParallel()`
    `<T>` | `static Queryable<SourceRecord<T>>` | `navigate(Queryable<? extends T> queryable, List<String> aliasList)` Make Queryable instance's data source records being able to access via aliases
    `<T>` | `static T` | `removeVar(String name)`
    `<T>` | `static void` | `setVar(String name, T value)`
    `` | `static void` | `shutdown(int mode)` Shutdown to release resources
    `<T>` | `static T` | `singleValue(Queryable<? extends T> queryable)` Returns single value of Queryable instance
    `<T>` | `static ForkJoinTask<T>` | `submit(Callable<T> callable)`
    `<U>` | `static CompletableFuture<U>` | `supplyAsync(Supplier<U> supplier)`
    `<T, U>` | `static CompletableFuture<U>` | `supplyAsync(Function<? super T, ? extends U> function, T param)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Property Detail

    - #### String var

  - ### Method Detail

    - #### <T> static T getVar(String name)

    - #### static boolean isParallel()

    - #### <T> static Queryable<SourceRecord<T>> navigate(Queryable<? extends T> queryable, List<String> aliasList)

      Make Queryable instance's data source records being able to access via aliases

      Parameters:
        `queryable` - the original Queryable instance
        `aliasList` - the aliases of clause `from` and joins
      Returns:
        the result Queryable instance
      Since:
        4.0.0

    - #### <T> static T removeVar(String name)

    - #### <T> static void setVar(String name, T value)

    - #### static void shutdown(int mode)

      Shutdown to release resources

      Parameters:
        `mode` - 0: immediate, 1: abort

    - #### <T> static T singleValue(Queryable<? extends T> queryable)

      Returns single value of Queryable instance

      throws:
        TooManyValuesException if the Queryable instance contains more than one value
      Parameters:
        `queryable` - the Queryable instance
      Returns:
        the single value
      Since:
        4.0.0

    - #### <T> static ForkJoinTask<T> submit(Callable<T> callable)

    - #### <U> static CompletableFuture<U> supplyAsync(Supplier<U> supplier)

    - #### <T, U> static CompletableFuture<U> supplyAsync(Function<? super T, ? extends U> function, T param)